<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>GoogleNav Connection</title>

<link href="style.css" rel="stylesheet" type="text/css">
</head>

<body>
<?php
// Thanks to Stefano Busti's (sbusti@nildram.co.uk) Serproxy program, which is a freeware, the Serial 
// communication is now converted in tcp/ip socket which is easier to read from PHP. 
// I had a problem to gather the NMEA sentences directly from the Com port with PHP 4.3 (which is my configuration)
// When my GPS device lost its connection to sat, it generally provoqued windows BSOD. Hence this application
// which is much more stable and allows a real socket connection.
// Attention : In order to kill this program when you click on disconnect, you must
// have microsoft's tasklist.exe and taskkill.exe programs in your \windows\system32 folder.
// These programs are delivered along XP Pro but not Home version.
// you can however find some places to download these binaries on the net - or download the Microsoft's support tools

function execInBackground($path, $exe, $args) {
// this function starts the proxy server which allows the transfert of Serial to IP communication 
   if (file_exists($path . $exe)) {
       chdir($path);
       if (substr(php_uname(), 0, 7) == "Windows"){
           pclose(popen("start \"SerProxy\" \"" . $exe . "\" " . escapeshellarg($args), "r"));   
       } else {
           exec("./" . $exe . " " . escapeshellarg($args) . " > /dev/null &");   
       }
   }
}

function connection(){
//Launches the connection to SerProxy
	$path=getcwd()."\\serproxy\\";
	execInBackground($path, "serproxy.exe","");
	read_nmea();
}
function disconnection(){
//kills the Serproxy instance - You need to have tasklist.exe and taskkill.exe in your /windows/system32 folder.
// We create a logfile from tasklist in order to get the PID number of the Serproxy instance
	$path=getcwd()."\\serproxy\\";
	exec("tasklist.exe>tasks.log");
    $in = @fopen("tasks.log", "r");
    if (! $in) {
		echo _STOP_SERPROXY_PROBLEM;
    } 
	$nb=0;
//Then each time we find serproxy in the log, we kill the program.
    while (!feof($in)) {
		$value = preg_replace('/\s+/', ' ', fgets($in,4096));
		list($prog,$pid,$session,$num,$mem)=explode(" ",$value);
		if ($prog=="serproxy.exe"){
			exec("taskkill /F /pid ".$pid);
			$nb++;
		}
    } 
	$message=_CONNECTION_CLOSED;
	if ($nb>1) {
		$message=$message.$nb._CONNECTION_TIMES;
	}
	if($nb==0){
		$message=$message._GPS_DISCONNECTED;
	}
	$message=$message.".<br>";
    fclose($in);
	return $message;
}

function parameters($comm_port, $speed, $bits, $stop_bits, $parity) {
// Defines the connection parameters for Serproxy - These parameters are
// stored in the /GoogleNav/serproxy/serproxy.cfg file.
	$path=getcwd()."\\serproxy\\";
    $out = @fopen($path."serproxy.cfg", "w");
	fputs($out,"comm_ports=".$comm_port."\n");
	fputs($out,"comm_baud=".$speed."\n");
	fputs($out,"comm_databits=".$bits."\n");
	fputs($out,"comm_stopbits=".$stop_bits."\n");
	fputs($out,"comm_parity=".$parity."\n");
	fputs($out,"timeout=300"."\n");
	fputs($out,"net_port".$comm_port."=5330"."\n");
    fclose($out);
}

function convdec($coord, $discr) {
$coord=$coord/100;
$dec=intval($coord)+($coord-intval($coord))*100/60;
if ($discr=="W" || $discr== "S") {
	$dec=$dec*-1;
	return $dec;
	} else {
	return $dec;
	}
}
function read_nmea() {
	set_time_limit(10);
	$fp = fsockopen ("127.0.0.1", 5330, $errno, $errstr, 30);
	if (!$fp) {
	   die ("$errstr ($errno)");
	}
	$compteur=0;
	$point=false;
	$status="";
	$fix=0;
	while (!$point) {
		$string=@fgets($fp, 4096);
		switch (substr($string,0,6)) {
			case "\$GPRMC" :
				list($sentence, $time, $status, $latitude, $NS, $longitude, $EW, $speed, $course, $date, $magvar, $magvarEW)= explode(",", trim($string)); 
				$latd=convdec($latitude, $NS);
				$lond=convdec($longitude, $EW);
				break;
			case "\$GPGGA" :					
				list($sentence, $time, $latitude, $NS, $longitude, $EW, $fix, $nbsat, $HDOP, $altitude,,,,,)= explode(",", trim($string)); 
				$latd=convdec($latitude, $NS);
				$lond=convdec($longitude, $EW);
				break;
			default :
			break;
		}
		$compteur++;

		if ($status=="A" and $fix == 1){
			$point=true;
		}
		if ($compteur==50){
			die(_LOCALIZATION_NOT_DEFINED);
		}
	}
echo _GPS_CONNECTED."<br>"._IN_SIGHT.round($nbsat,0)._SATELLITES.'<br>'.
_POSITION .round($latd,4).', '._LONGITUDE.round($lond,4).'.';
fclose ($fp);
}
include("init.php");
include("config.php");
include("set_lang.php");

set_lang();
error_reporting(E_ERROR | E_WARNING | E_PARSE);
$connect = $_POST['connect'];
$disconnect = $_POST['disconnect'];
$param = $_POST['param'];
$comm_port= $_POST['comm_port'];
$speed= $_POST['speed'];
$bits= $_POST['bits'];
$stop_bits= $_POST['stop_bits'];
$parity= $_POST['parity'];
$direct_connexion= $_GET['direct_connection'];
$direct_disconnexion= $_GET['direct_disconnection'];

if(!empty($direct_connection)) {
	$message=disconnection();
	connection();
}
if(!empty($direct_disconnection)) {
	$message=disconnection();
	echo $message;
}
if(!empty($connect)) {
	$message=disconnection();
//	$conn_string='mode com'.$comm_port.': baud='.$speed.' data='.$bits.' stop='.$stop_bits.' parity='.substr($parity,0,1).' xon=on';
//	echo $conn_string;
//	exec($conn_string);	
	parameters($comm_port, $speed, $bits, $stop_bits, $parity);
	connection();
}

if(!empty($disconnect)) {
	$message=disconnection();
	echo $message;
}

?>

</body>
</html>
